(define-module (ui ca certs ajax)
	       :use-module (alterator ajax)
	       :use-module (alterator effect)
	       :use-module (alterator woo)
	       :export (init))

(define (ui-read)
  (let* ((obj (woo-read-first "/ca/certs"))
	 (can_has_sign (woo-get-option obj 'can_has_sign)))
    (form-update-value-list obj)
    (update-effect)
    (form-update-visibility '("can_has_sign") can_has_sign)))

(define (ui-list)
  (form-update-enum "name"
      (woo-list "/ca/certs" 'language (form-value "language")))
  (form-update-enum "new_name"
      (woo-list "/ca/avail_hosts" 'language (form-value "language"))))

(define (on-autoupdate)
  (catch/message
    (lambda()
      (woo-write "/ca/certs"
                 'apply_autoupdate #t
                 'language (form-value "language")
                 'autoupdate (form-value "autoupdate")
                 'time (form-value "time"))
      (ui-read))))

(define (on-upload)
  (call-with-form-file
    "request"
    (lambda (path)
      (catch/message
        (lambda()
          (woo "upload" "/ca"
	       'request path
	       'language (form-value "language"))))))
  (ui-read))

(define (on-del-host)
  (catch/message
    (lambda()
      (woo-write "/ca/certs"
                 'del_host #t
                 'name (form-value "name")
                 'language (form-value "language"))
      (ui-list))))

(define (on-new-host)
  (catch/message
    (lambda()
      (woo-write "/ca/certs"
                 'new_host #t
                 'new_name (form-value "new_name")
                 'language (form-value "language"))
      (ui-list))))

(define (on-update-host)
  (catch/message
    (lambda()
      (woo-write "/ca/certs"
                 'update_host #t
                 'name (form-value "name")
                 'language (form-value "language"))
      (ui-list))))

(define (on-sign)
  (form-update-visibility '("can_has_sign") #f)
  (form-replace "/ca?download=output.pem"))

(define (init)
  (effect-enable "time" "autoupdate" #t)
  (init-effect)
  (ui-read)
  (ui-list)
  (form-bind-upload "upload_button" "click" "request" on-upload)
  (form-bind "sign_button" "click" on-sign)
  (form-bind "apply_autoupdate" "click" on-autoupdate)
  (form-bind "del_host" "click" on-del-host)
  (form-bind "new_host" "click" on-new-host)
  (form-bind "update_host" "click" on-update-host))
